# This code predicts the annual milage budget for each household in the dataset
# For base year, this is compared with the observed annual mileage distribution
# Output (annual milage budget) from this code goes is in as input to '3_Vehicle_fleet_mix.r'

mile_category <- function(x, act_value, cat_value) {
  
  for (i in x)
  {
  
    if(act_value[i] <= 10000){
      cat_value[i] <- 0;
    } else{
      if(act_value[i] <= 20000){
        cat_value[i] <- 1;  
      }
      else{
        if(act_value[i] <= 30000){
          cat_value[i] <- 2;
        }
        else{
          if(act_value[i] <= 40000){
            cat_value[i] <- 3;
          }
          else{
            if(act_value[i] <= 50000){
              cat_value[i] <- 4;
            }
            else{
              if(act_value[i] <= 60000){
                cat_value[i] <- 5;
              }
              else{
                if(act_value[i] <= 70000){
                  cat_value[i] <- 6;
                }
                else{
                  if(act_value[i] <= 80000){
                    cat_value[i] <- 7;
                  }
                  else{
                    if(act_value[i] <= 90000){
                      cat_value[i] <- 8;
                    }
                    else{
                      cat_value[i] <- 9;
                    }
                    
                  }
                }
              }
            }
          }
        }
      }
    }
  } 
  
  return (cat_value);
}

mileage_model <- function(data1, coefs_name_mile, coefs_mile) {
  
  data1$const <- 1;
  error_term <- rnorm(length(data1$const), mean=0,sd=4);
  
  expect_op <- data1[coefs_name_mile[1]] * coefs_mile[1];
  for (i in 2:(length(coefs_name_mile))) {
    expect_op <- expect_op + data1[coefs_name_mile[i]] * coefs_mile[i];
  }
  
  expect_op <- as.numeric(expect_op$const);
  expect_op <- (expect_op + error_term);
  expect_op[expect_op < 0.0] <- 0
  expect_op <- expect_op^(1/0.3);
  
  
  
  isVehicle <- data1$NCAR + data1$NVAN + data1$NSUV + data1$NPICK;
  isVehicle[isVehicle > 0] <- 1;
  data1$budget <- (expect_op * isVehicle) + data1$HHSIZE * 0.5 * 365;
  
  
  ### Predicted Choices
  NumHousehold <- nrow(data1);
  x = 1:NumHousehold;
  
  data1$omiles <- data1$CAR1 + data1$CAR2 + data1$CAR3 + data1$VAN1 + data1$VAN2 + data1$VAN3 + data1$SUV1 + data1$SUV2 + data1$SUV3 +
    data1$PICK1 + data1$PICK2 + data1$PICK3 + data1$MOTOR;
  
  data1$obs_mile <- 0;
  data1$pre_mile <- 0;
  data1$obs_mile <- mile_category(x, data1$omiles, data1$obs_mile);
  data1$pre_mile <- mile_category(x, data1$budget, data1$pre_mile);
  
  
  comp_obs_pred <- list(data1$obs_mile, data1$pre_mile);
  multhist(comp_obs_pred, xlab="Annual Mileage", ylab="Percent of Households", col = c("blue", "red"),  main = "Mileage Distribution",
           legend.text = c("Observed", "Predicted"), names.arg=c("<=10000","<=20000","<=30000","<=40000","<=50000","<=60000","<=70000","<=80000","<=90000",">90000"),
           breaks=seq(-0.5,10, by = 1),  ylim=c(0,0.4), freq = FALSE); 

  tmp <- data1[c("const","budget","omiles","obs_mile","pre_mile")];
  return (tmp);
} 




